#include <string.h>
#include <math.h>

#include "v2.h"

#ifdef NEED_POW2
static double pow2(double parm)
{
	return pow(2, parm);
}
#endif

static void Init(void)
{
	int a;
	
	unsigned char *Pal;
	
	/* Draw the white lines */
	memset(&Vid[(LINE-1)*COL], 255, COL);	
	memset(&Vid[V2_TOP*COL], 255, COL);
	
	/* Set the palette */
	for(a=16; a<136; a++)
	{
		Pal = &Palette[a*3];	/* 16..135 = 0x10..0x87 */

		*Pal++ = (a<0x60) ? 0 : (a-0x60) * 255 / 0x27;
		*Pal++ = (a<0x37) ? 0 : (a-0x37) * 255 / 0x50;
		*Pal   = a * 255 / 135;
		
		Pal += 120*3 - 2;

		*Pal++ = a * 255 / 135;
		*Pal++ = (a<0x37) ? 0 : (a-0x37) * 255 / 0x50;
		*Pal   = (a<0x60) ? 0 : (a-0x60) * 255 / 0x27;
	}
	
	fb_writepalette();
}

static void Done(void)
{
}

static void View(void)
{
	int a, max;
	char fps_str[32];
	unsigned char *Ptr;
	
	float Max, Min, MaxMinDiff;
	
	sprintf(fps_str, "FPS=%.1f", FPS);
	fb_center(0, fps_str);
	
	Ptr = Vid + COL * (LINE-2);
	
	memmove(
		&Vid[(V2_TOP+1)*COL], 
		&Vid[(V2_TOP+2)*COL], 
		(LINE-V2_TOP-2)*COL);
	
	*Ptr++ = 255;	
	
	max = COL-1;
	
	Min = log(V2_MIN) / log(2.0);
	Max = log(V2_MAX) / log(2.0);
	MaxMinDiff = Max-Min;
	
	for(a=1; a<max; a++)
	{
		register int dy, nyt = pow2(a * MaxMinDiff / max + Min);
		register float temp = Power[nyt]-Avg[nyt]/AvgCount;
		
		dy = temp<0.0 ? 0.0 :sqrt(temp) * 20.0;
		
		if(dy>135)dy=135;
		if(dy<16)dy=16;

		*Ptr = dy;
		
		Ptr++;
	}		
	
	*Ptr++ = 255;
}

Viewer V2 = {fb_is_required, 0, Init, Done, View};
